%global __brp_check_rpaths %{nil}
%global __requires_exclude ^libmpi
%global packname  nebula
%global packver   1.4.2
%global rlibdir   /usr/local/lib/R/library

Name:             R-CRAN-%{packname}
Version:          1.4.2
Release:          1%{?dist}%{?buildtag}
Summary:          Negative Binomial Mixed Models Using Large-Sample Approximation for Differential Expression Analysis of ScRNA-Seq Data

License:          GPL-3
URL:              https://cran.r-project.org/package=%{packname}
Source0:          %{url}&version=%{packver}#/%{packname}_%{packver}.tar.gz


BuildRequires:    R-devel >= 4.1
Requires:         R-core >= 4.1
BuildRequires:    R-CRAN-doRNG >= 1.8.6
BuildRequires:    R-CRAN-foreach >= 1.5.2
BuildRequires:    R-CRAN-future >= 1.32.0
BuildRequires:    R-CRAN-Rcpp >= 1.0.7
BuildRequires:    R-CRAN-doFuture >= 0.12.2
BuildRequires:    R-CRAN-nloptr 
BuildRequires:    R-stats 
BuildRequires:    R-CRAN-Matrix 
BuildRequires:    R-methods 
BuildRequires:    R-CRAN-RSpectra 
BuildRequires:    R-CRAN-Rfast 
BuildRequires:    R-CRAN-trust 
BuildRequires:    R-CRAN-RcppEigen 
Requires:         R-CRAN-doRNG >= 1.8.6
Requires:         R-CRAN-foreach >= 1.5.2
Requires:         R-CRAN-future >= 1.32.0
Requires:         R-CRAN-Rcpp >= 1.0.7
Requires:         R-CRAN-doFuture >= 0.12.2
Requires:         R-CRAN-nloptr 
Requires:         R-stats 
Requires:         R-CRAN-Matrix 
Requires:         R-methods 
Requires:         R-CRAN-RSpectra 
Requires:         R-CRAN-Rfast 
Requires:         R-CRAN-trust 

%description
A fast negative binomial mixed model for conducting association analysis
of multi-subject single-cell data. It can be used for identifying marker
genes, differential expression and co-expression analyses. The model
includes subject-level random effects to account for the hierarchical
structure in multi-subject single-cell data. See He et al. (2021)
<doi:10.1038/s42003-021-02146-6>.

%prep
%setup -q -c -n %{packname}

# fix end of executable files
find -type f -executable -exec grep -Iq . {} \; -exec sed -i -e '$a\' {} \;
# prevent binary stripping
[ -d %{packname}/src ] && find %{packname}/src -type f -exec \
  sed -i 's@/usr/bin/strip@/usr/bin/true@g' {} \; || true
[ -d %{packname}/src ] && find %{packname}/src/Make* -type f -exec \
  sed -i 's@-g0@@g' {} \; || true
# don't allow local prefix in executable scripts
find -type f -executable -exec sed -Ei 's@#!( )*/usr/local/bin@#!/usr/bin@g' {} \;

%build

%install

mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css
# remove buildroot from installed files
find %{buildroot}%{rlibdir} -type f -exec sed -i "s@%{buildroot}@@g" {} \;

%files
%{rlibdir}/%{packname}
